"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var core_1 = require("@angular/core");
var modal_directive_1 = require("./modal.directive");
var document_ref_1 = require("../document-ref");
var ModalComponent = /** @class */ (function () {
    function ModalComponent(doc, renderer) {
        var _this = this;
        this.doc = doc;
        this.renderer = renderer;
        this.onModalClick = function ($event) {
            if (_this.backdropCloseable && document.contains($event.target)) {
                _this.hide();
            }
        };
        this.backdropCloseable = _.isUndefined(this.backdropCloseable) ? true : this.backdropCloseable;
    }
    ModalComponent.prototype.onHidden = function () { };
    ModalComponent.prototype.canHideModel = function () {
        var hiddenResult = Promise.resolve(true);
        if (this.beforeHidden) {
            var result = this.beforeHidden();
            if (typeof result !== undefined) {
                if (result.then) {
                    hiddenResult = result;
                }
                else if (result.subscribe) {
                    hiddenResult = result.toPromise();
                }
                else {
                    hiddenResult = Promise.resolve(result);
                }
            }
        }
        return hiddenResult;
    };
    ModalComponent.prototype.hide = function () {
        var _this = this;
        this.canHideModel().then(function (canHide) {
            if (!canHide) {
                return;
            }
            _this.renderer.setElementClass(_this.doc.body, 'modal-open', false);
        });
    };
    ModalComponent.prototype.show = function () {
        this.renderer.setElementClass(this.doc.body, 'modal-open', true);
    };
    __decorate([
        core_1.ViewChild(modal_directive_1.ModalContainerDirective),
        __metadata("design:type", modal_directive_1.ModalContainerDirective)
    ], ModalComponent.prototype, "modalContainerHost", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ModalComponent.prototype, "id", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ModalComponent.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ModalComponent.prototype, "backdropCloseable", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Function)
    ], ModalComponent.prototype, "beforeHidden", void 0);
    ModalComponent = __decorate([
        core_1.Component({
            selector: 'dc-modal',
            template: "<div>modal</div><template dcModalContainerHost></template>",
            styles: ['']
        }),
        __metadata("design:paramtypes", [document_ref_1.DocumentRef, core_1.Renderer])
    ], ModalComponent);
    return ModalComponent;
}());
exports.ModalComponent = ModalComponent;
//# sourceMappingURL=modal.component.js.map